import {Component, OnInit, ViewChild} from '@angular/core';

import {MapCateComponent} from 'paotuibao-components';

import { Storage,StorageConfig } from '@ionic/storage';
import {ActivatedRoute} from "@angular/router";

@Component({
  selector: 'design',
  templateUrl: './design.component.html',
  styleUrls: ['./design.component.scss']
})
export class DesignComponent implements OnInit {
  setting: any;
  @ViewChild('cate') cate: MapCateComponent;

  id: string = 'post_index';

  storage:Storage =  new Storage({
    storeName: 'imeepos_runner_design'
  })
  constructor(
      private route: ActivatedRoute
  ) {
    this.setting = {
      base: {
        title: '发单首页',
        share: {
          title: '欢迎使用小明跑腿',
          desc: '找跑腿/找服务就用小明跑腿',
          image: ''
        }
      },
      header: {
        title: '小明跑腿',
        left: {
          title: '',
          link: ''
        },
        right: {
          title: '',
          link: ''
        }
      },
      cates: [
        {
          title: '帮我买',
          active: true,
          children: [
            {
              title: '买烟酒',
              active: true
            },
            {
              title: '买小吃',
              active: false
            },
            {
              title: '买水果',
              active: false
            },
            {
              title: '买药品',
              active: false
            },
            {
              title: '买咖啡',
              active: false
            }
          ]
        },
        {
          title: '帮我送',
          active: false,
          children: []
        },
        {
          title: '帮我取',
          active: false,
          children:[]
        },
        {
          title: '代排队',
          active: false,
          children:[]
        },
        {
          title: '万能帮帮',
          active: false,
          children: [
            {
              title: '宠物照顾',
              active: true
            },
            {
              title: '代办缴费',
              active: false,
            },
            {
              title: '代缴罚款',
              active: false
            },
            {
              title: '开锁换锁',
              active: false
            }
          ]
        },
        {
          title: '自定义',
          active: false,
          children: []
        }
      ]
    }
    this.storage.get('post_index').then(res=>{
      if(res){
        console.log(res)
        this.setting = res;
      }else{
        this.storage.set('post_index',this.setting).then(res=>{
          console.log('保存成功')
        })
      }
    })
  }

  ngOnInit() {
    this.route.params.subscribe(res=>{
      console.log(res);
      this.id = res.id;
    })
  }

  onAdd(c){
    this.cate.onActive(c)
  }

  onSave(e){
    this.setting = e;
    this.storage.set('post_index',this.setting).then(res=>{
      console.log('保存成功');
    });
    
  }

}
