import {Component, EventEmitter, Input, OnInit, Output} from '@angular/core';

@Component({
  selector: 'edits',
  templateUrl: './edits.component.html',
  styleUrls: ['./edits.component.scss']
})
export class EditsComponent implements OnInit {
  navs: any[];
  _item: any;

  base: any;
  header: any;
  cates: any[];

  @Input() set setting(val: any){
    this.base = val['base'];
    this.header = val['header'];
    this.cates = val['cates'];
  }
  @Output() onSave: EventEmitter<any> = new EventEmitter()
  @Output() onAdd: EventEmitter<any> = new EventEmitter()

  constructor() {
    this.navs = [
      {
        title: '页面设置',
        active: true,
        code: 'base'
      },
      {
        title: '顶部导航',
        active: false,
        code: 'header'
      },
      {
        title: '分类设置',
        active: false,
        code: 'cate'
      }
    ]
    this._item = this.navs[0]
  }

  ngOnInit() {

  }

  _clickNav(item){
    this.navs.map(res=>{
      res.active = false;
    })
    item.active = true;
    this._item = item;
  }

  delChild(cate,i){
    cate.children.splice(i,1)
  }

  addChild(cate){
    let item = {
      title: '',
      active: false
    }
    cate.children.push(item)
    this.onAdd.emit(cate)
  }

  _onSave(){
    let data = {
      base: this.base,
      header: this.header,
      cates: this.cates
    }

    this.onSave.emit(data)
  }

  changeTitle(){
    console.log(this.base);
    document.title = this.base.title;
  }

}
