import { Component, OnInit } from '@angular/core';
import {Http,Headers} from "@angular/http";
import 'rxjs/Rx';
import {Router} from "@angular/router";
declare const sysinfo;
@Component({
  selector: 'list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.scss']
})
export class ListComponent implements OnInit {
  items: any[];
  overViewItems: any;
  ready: boolean = false;

  page: number = 1;
  total: number = 0;
  option: any;

  constructor(
      private http: Http,
      private router: Router
  ) {
    this.option = {
      title: {
        text: '新增会员统计'
      },
      tooltip : {
        trigger: 'axis',
        axisPointer: {
          type: 'cross',
          label: {
            backgroundColor: '#6a7985'
          }
        }
      },
      toolbox: {
        feature: {
          saveAsImage: {}
        }
      },
      grid: {
        left: '3%',
        right: '4%',
        bottom: '3%',
        containLabel: true
      },
      xAxis : [
        {
          type : 'category',
          boundaryGap : false,
          data : []
        }
      ],
      yAxis : [
        {
          type : 'value'
        }
      ],
      series : [
        {
          name:'新增会员',
          type:'line',
          stack: '总量',
          label: {
            normal: {
              show: true,
              position: 'top'
            }
          },
          areaStyle: {normal: {}},
          data:[]
        }
      ]
    };
    this.overViewItems = [
      {
        title: '会员总数',
        num: 0
      },{
        title: '跑腿总数',
        num: 0
      },{
        title: '今日增加会员',
        num: 0
      },{
        title: '今日增加跑腿',
        num: 0
      }
    ]
  }

  ngOnInit() {
    this.getList(1);
  }

  getList(page: number){
    let url = `${sysinfo.siteroot}app/index.php?i=${sysinfo.uniacid}&c=entry&do=admin&m=imeepos_runner&act=api&__do=member.list`;
    let headers = new Headers();
    headers.append("Content-Type", "application/x-www-form-urlencoded");
    this.http.post(url,{page: page},{headers: headers}).map(res=>res.json()).subscribe(res=>{
      console.log(res)
      this.items = res['info']['list'];

      this.overViewItems = [
        {
          title: '会员总数',
          num: res['info'].totalMemberNum
        },{
          title: '跑腿总数',
          num: res['info'].totalRunnerNum
        },{
          title: '今日增加会员',
          num: res['info'].stodayMemberNum
        },{
          title: '今日增加跑腿',
          num: res['info'].todayRunnerNum
        }
      ]
      this.ready = true;
      this.total = res['info'].totalMemberNum
      let weeks = res['info']['weeks'];
      weeks.map(res=>{
        this.option.xAxis[0].data.push(res.time_str)
        this.option.series[0].data.push(res.sum)
      })
      console.log(weeks);
    })
  }

  look(item){
    this.router.navigate(['member','detail',item.id])
  }

  delete(item,i){
    let url = `${sysinfo.siteroot}app/index.php?i=${sysinfo.uniacid}&c=entry&do=admin&m=imeepos_runner&act=api&__do=member.delete`;
    let headers = new Headers();
    headers.append("Content-Type", "application/x-www-form-urlencoded");
    this.http.post(url,{id: item.id},{headers: headers}).map(res=>res.json()).subscribe(res=>{
      console.log(res)
      this.items.splice(i,1)
    })
  }

  onPage(e){
    e = e > 0 ? e : 1;
    this.getList(e)
  }

}
