import { Component, OnInit } from '@angular/core';

import {OauthService} from 'services-components';


@Component({
  selector: 'update',
  templateUrl: './update.component.html',
  styleUrls: ['./update.component.scss']
})
export class UpdateComponent implements OnInit {
  files: any[] = [];
  version: string = '1.00';
  updatedate: string = '00';
  message: string = '最新版';
  updateInfo: string = '';
  constructor(
      public oauth: OauthService
  ) { }

  ngOnInit() {
    this.init();
  }
  upgrade(){
    this.oauth.download({}).subscribe(res=>{
      if(res.result == 1){
        this.updateInfo = `已更新${res.info.success}个文件 / 共 ${res.info.total}个文件`;
      }else{
        this.updateInfo = '文件更新更新完毕,正在同步数据库...';
        setTimeout(()=>{
          this.updateTables();
        },500)
      }
    })
  }

  init(){
    this.oauth.getInfo({}).subscribe(res=>{
      this.files = res.info['files'] ? res.info['files'] : [];
      this.version = res.info['version'];
      this.updatedate = res.info['updatedate'];
      this.message = res.info['message'];
    })
  }

  updateTables(){
    this.oauth.updateTables({}).subscribe(res=>{
      this.updateInfo = '数据库同步完毕';
    })
  }

  delVersion(){
     this.oauth.version({}).subscribe(res=>{
       console.log(res)
       this.version = '1.0.0';
       this.init();
     })
  }

  check(){
    this.oauth.check({}).subscribe(res=>{
      this.updateInfo = res.info['message'];
    })
  }


  download(){
    if(confirm('您确定上一版本要同步最新版么？请注意数据备份，一旦升级成功不可后退！')){
      this.upgrade();
    }
  }

}
