import {Component, ElementRef, OnInit, Renderer2} from '@angular/core';
import {DomSanitizer} from "@angular/platform-browser";
import {ActivatedRoute} from "@angular/router";

@Component({
  selector: 'preview',
  templateUrl: './preview.component.html',
  styleUrls: ['./preview.component.scss']
})
export class PreviewComponent implements OnInit {

  iframeUrl: any;
  constructor(
      private route: ActivatedRoute,
      public domSanitizer: DomSanitizer,
      private ele: ElementRef,
      private renderer: Renderer2
  ) {

  }

  ngOnInit() {
    this.route.params.subscribe(res=>{
      this.iframeUrl = this.domSanitizer.bypassSecurityTrustResourceUrl(decodeURI(res.url));
    })
  }

}
