import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import {Routes, RouterModule} from "@angular/router";
import {DesignComponent} from "./design/design.component";
import {DesignModule} from "./design/design.module";
import {IframeComponent} from "./iframe/iframe.component";
import {IframeModule} from "./iframe/iframe.module";
import { MoneyLodashComponent } from './money-lodash/money-lodash.component';
import {PreviewComponent} from "./preview/preview.component";
import {PreviewModule} from "./preview/preview.module";

import {WidgetBoxOverviewModule} from 'youzan-components';
import {HttpModule, JsonpModule} from "@angular/http";
import {MemerModule} from "./memer/memer.module";
import {SettingModule} from "./setting/setting.module";
import {OauthModule} from "./oauth/oauth.module";

let routes: Routes = [
  {
    path: 'runner/design/:id',
    component: DesignComponent
  },
  {
    path: 'runner/iframe/:url',
    component: IframeComponent
  },
  {
    path: 'runner/preview/:url',
    component: PreviewComponent
  },
  {
    path: 'runner/money/lodash',
    component: MoneyLodashComponent
  }
]
@NgModule({
  imports: [
    CommonModule,
    RouterModule.forChild(routes),
      HttpModule,
      JsonpModule,
    DesignModule,
      IframeModule,
      PreviewModule,
    MemerModule,
    WidgetBoxOverviewModule,
    SettingModule,
    OauthModule
  ],
  declarations: [MoneyLodashComponent]
})
export class RunnerModule { }
